#include <stdio.h>
#include <ctype.h>

// stdin-rol olvas, stdout-ra ir. A \uxxxx alaku Unicode-karaktereket utf8-ra konvertalja.

static char tomb[7];
static int usorsz = 0;		// hanyadik karakter a Unicode-ban (tomb-ben)
static unsigned int kod = 0;


static void univeg(void)
{	// Kiuriti a tombot
tomb[0] = usorsz = 0;
}

static void unov(char c)
{	// hozzatesz egy karaktert tomb-hoz
tomb[usorsz++] = c;
tomb[usorsz] = 0;
}

static void utorl(char c)
{	// kiirja es kiuriti a tombot
fputs(tomb,stdout);
putchar(c);
univeg();
}

static void utf2(void)
{	// Kiirja kod utolso ket utf8 karakteret (also 12 bitjet)
kod &= 0xfff;
putchar(0x80 | (kod >> 6));
putchar(0x80 | (kod & 0x3f));
univeg();
return;
}


int main()
{
unsigned int c,ret = 0;

while( (c=getchar()) != EOF)
	{
//	printf("usorsz = %d, c = %c, tomb=%s\n",usorsz,c,tomb);
	switch(usorsz)
		{
		case 0:	if(c == '\\')
				unov(c);
			else	putchar(c);
			break;
		case 1:	if(tolower(c) == 'n')	// uj sor
				{
				//utorl('\n');
				univeg();
				putchar('\n');
				break;
				}
			if(tolower(c) != 'u')
				{
				utorl(c);
				ret = 1;
				}
			else	{
				unov(c);
				kod = 0;
				}
			break;
		case 2:
		case 3:
		case 4:
		case 5: if(isxdigit(c))
				unov(c);	// usorsz 1-gyel nott
			else	{
				utorl(c);
				ret = 1;
				break;
				}
			if(usorsz < 6)
				break;
			sscanf(tomb+2,"%x",&kod);
//			printf("kod=%x\n",kod);
			if( (kod & ~0x7f) == 0)
				{	// 1 byte
				putchar(kod);
				univeg();
				break;
				}
			if( (kod & ~0x7ff) == 0)
				{	// 2 byte
				putchar(0xc0 | (kod >> 6));
				putchar(0x80 | (kod & 0x3f));
				univeg();
				break;
				}
			if( (kod & ~0xffff) == 0)
				{	// 3 byte
				putchar(0xe0 | (kod >> 12));
				utf2();
				break;
				}
			else	{	// 4 byte. Ide nem jutunk 4 hexa jeggyel.
				putchar(0xf0 | (kod >> 18));
				kod &= 0x3ffff;
				putchar(0x80 | (kod >>12));
				utf2();
				break;
				}
		}	// switch vege
	}		// while vege
return ret;
}
