#include <string.h>

static const struct magyarstr {
	unsigned char lat2kis,	// latin2 kisbetű
		lat2nagy;	// latin2 és nagybetű
	unsigned char kicsi[2],	// utf8 kisbetu
		nagy[2];	// utf8 nagybetu
	} utf8hu[] = { { '', '', { '\xc3', '\xa1' }, { '\xc3', '\x81' } },	// á
		       { '', '', { '\xc3', '\xa9' }, { '\xc3', '\x89' } },	// é
		       { '', '', { '\xc3', '\xad' }, { '\xc3', '\x8d' } },	// í
		       { '', '', { '\xc3', '\xb3' }, { '\xc3', '\x93' } },	// ó
		       { '', '', { '\xc3', '\xb6' }, { '\xc3', '\x96' } },	// ö
		       { '', '', { '\xc5', '\x91' }, { '\xc5', '\x90' } },	// ő
		       { '', '', { '\xc3', '\xba' }, { '\xc3', '\x9a' } },	// ú
		       { '', '', { '\xc3', '\xbc' }, { '\xc3', '\x9c' } },	// ü
		       { '', '', { '\xc5', '\xb1' }, { '\xc5', '\xb0' } } };	// ű

int utf8hukar(unsigned char *str, const struct magyarstr **eredm)
{	// megkeresi *str, *str+1-et utf8hu-ban. Visszaadja a byteszamot es az utf8hu-beli rekordot, ahol megtalalta.
const struct magyarstr *mut;

for(mut=utf8hu; mut < utf8hu+sizeof(utf8hu)/sizeof(struct magyarstr); mut++)
	{
	//printf("%2x  %2x %2x\n",*str,mut->lat2kis,mut->lat2nagy);
	if(*str == mut->lat2kis || *str == mut->lat2nagy)
		{
		*eredm = mut;
		return 1;
		}
	if(memcmp(str,mut->kicsi,2) == 0 || memcmp(str,mut->nagy,2) == 0)
		{
		*eredm = mut;
		return 2;
		}
	}
*eredm = NULL;
return 0;
}

#ifdef	DEBUG

#include <stdio.h>

int main()
{
static char kicsi[] = "aáeéiíoó:ö\"őuú:ü\"ű";
char *mut;

for(mut=kicsi; *mut; mut += 3)
	{
	printf("%c %.2s",*mut, mut+1);
	utf8upper(mut+1);
	printf(" %.2s\n",mut+1);
	}
return 0;
}

#endif
