#include <stdio.h>
#include <string.h>
#include <ctype.h>

// Ki akarunk irni egy ekezetes szoveget H betu szelessegben, V betut meghagyva az elejen, azaz %H.Vs formaban.
// Annyival tobb byte-ot kell kiirni, ahannyal tobb byte-ot foglal az elso V betu V-nel. Vagyis igy:
// x = utf8byte(szoveg,V); printf("%-*.*s",H+x,V+x,szoveg);
static int utf8byte(const char *str,int betuszam)
{	// "betu" darab betut akarok str-bol kiirni. Hany byte-tal tobbet irjak ki?
int b, c, byte, betu;

betu = betuszam < 0? -betuszam: betuszam;
b = byte = 0;
while(*str && ( (c = *str++ & 0xC0) == 0x80 || b < betu) )
	{
	//printf("        b=%d, c=%x, byte=%d\n",b,c,byte);
	if(c == 0x80)
		byte++;	// utf8 2., 3. vagy 4. byte-ja, de printf azt hiszi, kulon betu
	else	b++;	// betuszam. Nem ekezetes, vagy az ekezetes utf8-kod elso byte-ja.
	}
return betuszam < 0? -byte: byte;
}



int main(int argc, char *argv[])
{
struct flagstr {
	int nolf:1;	// nincs a sor vegen \n
	} flag;
int optind,c,hossz;
char *fmt;

flag.nolf = 0;
optind = 1;
if(optind < argc && strcmp(argv[optind],"-n") == 0)
	{
	flag.nolf = 1;
	optind++;
	}
if(optind >= argc || strcmp(argv[optind],"-h") == 0)
	{
	fprintf(stderr,"utf8kiir [ -h ] [ -n ] hosszlista szoveg1...\n"
		"Pl.: utf8kiir '-10 1 8' 'első' - 'ötödik'\n");
	return 1;
	}
fmt = argv[optind++];
//puts(fmt);
for(c=optind; c < argc; c++)
	{
	if(sscanf(fmt,"%d",&hossz) < 1)
		break;	// nincs tobb hosszusag
	fmt += strspn(fmt,"-0123456789");
	fmt += strspn(fmt," ");
	//printf("%d %d %s\n",hossz,hossz+utf8byte(argv[c],hossz),argv[c]);
	if(hossz)
		printf("%*s",hossz+utf8byte(argv[c],hossz),argv[c]);
	else
		printf("%s",argv[c]);
	}
if(flag.nolf == 0)
	puts("");
return 0;
}
