#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <iconv.h>
#include <sys/stat.h>
#include <libgyim.h>
#include "utf8hu.h"

static int ervenytelen(char *in);

int main(int argc, char *argv[])
{
char *in,*out,*eredm;
int ret;
size_t b,k;	// in es out merete
iconv_t cd;

in = filemem(argc >= 2? argv[1]: NULL);
k = b = strlen(in); // az output rovidebb lesz, mint az input volt, ezert foglaltunk ennyi helyet
if( (eredm = out = malloc(k+1)) == NULL)
	{
	fprintf(stderr,"Kicsi a memoria\n");
	exit(1);
	}

if( (cd = iconv_open("8859_2//","utf-8//")) == (iconv_t)(-1) )
	{
	fprintf(stderr,"iconv elokeszitese nem sikerult\n");
	return(1);
	}
ret = 0;
while(b)
	{
	size_t r;
	int i,n,sor,kar;
	char *mut;

	r = iconv(cd,&in,&b,&out,&k);
//	fprintf(stderr,"b=%d, k=%d\n",b,k);
	if(r != (size_t)(-1))
		break;	// kesz
	if(r == (size_t)(-1) && errno == 84)
		{
		for(sor=kar=1, mut=eredm; mut < out; mut++)
			{	// megkeressuk a hiba helyet sor,kar formaban
			if(*mut == '\n')
				{
				sor++;
				kar = 1;
				}
			else	kar++;
			}
		n = ervenytelen(in);
//		fprintf(stderr,"ret elott: %.10s\n",out-10);
		if(!iconvgyl(n,&in,&b,&out,&k))
			{
			fprintf(stderr,"%d. sor, %d. karakter: %d ervenytelen byte:",sor,kar,n);
			for(i=0; i < n; i++)
				{	// kiirjuk az ervenytelen byte-okat
				fprintf(stderr," %02X",(unsigned char)*in);
				*out++ = *in++;
				b--; k--;
				}
			fprintf(stderr,"\n");
			}
//		fprintf(stderr,"ret utan: %.10s\n",out-10);
		iconv(cd,NULL,NULL,NULL,NULL);
		continue;
		}
	else	{
		fprintf(stderr,"errno=%d: %s\n",errno,strerror(errno));
		fprintf(stderr,"Valami gaz van. errno=%d. %zd megmaradt byte.\n",errno,b);
		ret=3;
		break;
		}
	}
if(ret == 0)
	{
	fwrite(eredm,1,out-eredm,stdout);
	fprintf(stderr,"%td kiirt karakter\n",out-eredm);
	}
return(ret);
}


static int ervenytelen(char *in)
{
int ret;

for(ret=0; *in&0x80; ret++,in++)	// megkeressuk az elso 7-bitest
	;
return ret;
}
